VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Auto-automobil"
   ClientHeight    =   7935
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9615
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   529
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   641
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdLegend 
      Caption         =   "Legenda"
      Height          =   615
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   1575
   End
   Begin VB.CommandButton cmdTrasa 
      Caption         =   "Nati trasu"
      Height          =   615
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   1575
   End
   Begin MSComDlg.CommonDialog cdFile 
      Left            =   1560
      Top             =   240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Nati mapu"
      Filter          =   "Soubory map (*.txt)|*.txt|Vechny soubory|*.*"
   End
   Begin VB.PictureBox pMap 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   7710
      Left            =   1800
      ScaleHeight     =   510
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   510
      TabIndex        =   1
      Top             =   120
      Width           =   7710
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Nati mapu"
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Cislo 38

Option Explicit

' Vyctovy typ pro oznaceni jednotlivych poli mapy
Private Enum ePole
    Mimo = 0
    Cesta
    Trasa
    Start
    Cil
End Enum

' Struktura predstavujici bod v rovine
Private Type tBod
    x As Integer
    y As Integer
End Type

' Globalni promenne
Dim Mapa() As ePole                             ' Mapa
Dim MapWidth As Integer, MapHeight As Integer   ' Rozmery mapy
Dim Meritko As Integer                          ' Meritko pro zobrazeni mapy
Dim Barva(0 To 4) As Long                       ' Barvy pro jednotliva policka mapy
Dim StartPos As tBod                            ' Pozice startu

' Konstruktor bodu
Private Function Bod(x As Integer, y As Integer) As tBod
    Bod.x = x
    Bod.y = y
End Function

' Vykresli bod na danou pozici vzhledem k meritku
Sub PutBod(x As Integer, y As Integer, color As Long)
    pMap.Line (x * Meritko, y * Meritko)-(x * Meritko + Meritko - 1, y * Meritko + Meritko - 1), color, BF
End Sub

' Inicializuje barvy pro jednotliva policka mapy
Sub InitBarvy()
    Barva(Mimo) = RGB(0, 0, 0)
    Barva(Cesta) = RGB(0, 128, 0)
    Barva(Trasa) = RGB(0, 255, 0)
    Barva(Start) = RGB(0, 0, 255)
    Barva(Cil) = RGB(255, 0, 255)
End Sub

' Nacte mapu ze souboru do dvourozmerneho pole v ciselnem formatu vyctoveho typu ePole
Sub NactiMapu(sFile As String)
    Dim lFile As Long, sLine As String
    Dim i As Integer, l As Long
    
    lFile = FreeFile
    Open sFile For Input As lFile
    MapHeight = 0: MapWidth = 0
    
    Do While Not EOF(lFile)
        Line Input #lFile, sLine
        If MapWidth = 0 Then MapWidth = Len(sLine)
        MapHeight = MapHeight + 1
        
        ' Kontrola rozmeru mapy
        If (Len(sLine) <> MapWidth) Or (Len(sLine) > 255) Or (MapHeight > 255) Then
            MsgBox "Soubor s mapou nen platn.", vbOKOnly Or vbInformation, "Auto-automobil"
            MapHeight = 0: MapWidth = 0
            Close lFile
            Exit Sub
        End If
        
        ' Zmena rozmeru pole
        If MapHeight = 1 Then
            ReDim Mapa(1 To MapWidth, 1 To MapHeight)
        Else
            ReDim Preserve Mapa(1 To MapWidth, 1 To MapHeight)
        End If
        
        ' Prevedeni znaku predstavujicich policko na vyctovy typ ePole
        For i = 1 To MapWidth
            l = InStr("X.:SC", Mid(sLine, i, 1))
            If l = 0 Then
                MsgBox "Soubor s mapou nen platn.", vbOKOnly Or vbInformation, "Auto-automobil"
                MapHeight = 0: MapWidth = 0
                Close lFile
                Exit Sub
            Else
                Mapa(i, MapHeight) = l - 1
                If Mapa(i, MapHeight) = Start Then StartPos = Bod(i, MapHeight)
            End If
        Next i
    Loop
    Close lFile
End Sub

' Vykresli mapu v urcitem meritku
Sub VykresliMapu()
    Dim x As Integer, y As Integer
    
    If MapWidth = 0 Or MapHeight = 0 Then Exit Sub
    
    Meritko = 510 / IIf(MapWidth > MapHeight, MapWidth, MapHeight)
    pMap.Width = MapWidth * Meritko + 4
    pMap.Height = MapHeight * Meritko + 4
    Me.Width = (pMap.Width + pMap.Left + 14) * 15
    Me.Height = (pMap.Height + pMap.Top + 33) * 15
    
    For y = 0 To MapHeight - 1
        For x = 0 To MapWidth - 1
            PutBod x, y, Barva(Mapa(x + 1, y + 1))
        Next x
    Next y
End Sub

' Zobrazi trasu nactenou ze souboru
Sub NactiTrasu(sFile As String)
    Dim lFile As Long, sZnak As String, Povel As tBod, tempPos As tBod, Pos As tBod, Speed As tBod
    Dim bBrzda As Boolean, Brzdi As Boolean, color As Long
    
    Pos = StartPos
    Speed = Bod(0, 0)
    bBrzda = False
    
    lFile = FreeFile
    Open sFile For Input As lFile
    Do While Not EOF(lFile)
        Input #lFile, sZnak
        Povel.x = CInt(sZnak)
        Input #lFile, sZnak
        Povel.y = CInt(sZnak)
        
        Speed.x = Speed.x + Povel.x
        Speed.y = Speed.y - Povel.y
        If bBrzda Then
            If Speed.x > 5 Then Speed.x = 5
            If Speed.x < -5 Then Speed.x = -5
            If Speed.y > 5 Then Speed.y = 5
            If Speed.y < -5 Then Speed.y = -5
        End If
        
        tempPos = Bod(Pos.x + Speed.x, Pos.y + Speed.y)
        Brzdi = False
        If tempPos.x < 1 Or tempPos.y < 1 Or tempPos.x > MapWidth Or tempPos.y > MapHeight Then
            Brzdi = True
        ElseIf Mapa(tempPos.x, tempPos.y) = Mimo Then
            Brzdi = True
        End If
        If Brzdi Then
            bBrzda = True
            Speed = Bod(0, 0)
            tempPos = Pos
        End If
        
        Pos = tempPos
        color = IIf(Brzdi, RGB(255, 0, 0), RGB(255, 255, 0))
        If Mapa(Pos.x, Pos.y) = Cil Then color = RGB(255, 128, 255)
        PutBod Pos.x - 1, Pos.y - 1, color
    Loop
    Close lFile
    
    If Mapa(Pos.x, Pos.y) <> Cil Then MsgBox "Trasa neskonila v cli!", vbOKOnly Or vbInformation, frmMain.Caption
End Sub

' Zobrazi legendu
Private Sub cmdLegend_Click()
    frmLegend.Show
End Sub

' Zobrazi dialog pro vyber souboru s mapou a nacte vybrany soubor
Private Sub cmdLoad_Click()
    Dim sFile As String
    
    cdFile.Filter = "Soubory map (*.txt)|*.txt|Vechny soubory|*.*|"
    cdFile.Flags = cdlOFNHideReadOnly
    On Error GoTo chyba
    cdFile.ShowOpen
    On Error GoTo 0
    
    sFile = cdFile.FileName
    If Trim(Dir(sFile)) = "" Then
        MsgBox "Zadan soubor neexistuje.", vbOKOnly Or vbInformation, "Auto-automobil"
        Exit Sub
    End If
    
    NactiMapu sFile
    VykresliMapu
    
chyba:
End Sub

' Zobrazi dialog pro vyber souboru s trasou a nacte vybrany soubor
Private Sub cmdTrasa_Click()
    Dim sFile As String
    
    If MapWidth = 0 Or MapHeight = 0 Then
        MsgBox "Nen natena dn mapa.", vbOKOnly Or vbInformation, frmMain.Caption
        Exit Sub
    End If
    
    cdFile.Filter = "Soubory tras (*.txt)|*.txt|Vechny soubory|*.*|"
    cdFile.Flags = cdlOFNHideReadOnly
    On Error GoTo chyba
    cdFile.ShowOpen
    On Error GoTo 0
    
    sFile = cdFile.FileName
    If Trim(Dir(sFile)) = "" Then
        MsgBox "Zadan soubor neexistuje.", vbOKOnly Or vbInformation, "Auto-automobil"
        Exit Sub
    End If
    
    NactiTrasu sFile
    
chyba:
End Sub

Private Sub Form_Load()
    InitBarvy
    MapHeight = 0: MapWidth = 0
End Sub
